#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const int mod=998244353;
int n,k,p[200005],ss[200005];
vector<int>v[200005];
long long int otg=1;
void dfs(int beg,int par,long long int num)
{
    int w;
    if(ss[beg])num++;
    for(int i=0;i<v[beg].size();i++)
    {
        w=v[beg][i];
        if(w!=par)
        {
            dfs(w,beg,num);
        }
    }
    if(!ss[beg])otg=(otg*(num+1))%mod;
}
void read()
{
    cin>>n>>k;
    int h;
    for(int i=1;i<=k;i++)
    {
        cin>>p[i];
        ss[p[i]]=1;
    }
    for(int i=1;i<n;i++)
    {
        cin>>h;
        v[h].push_back(i+1);
        v[i+1].push_back(h);
    }
    if(k!=1)
    {
        dfs(1,1,0);
    }
    cout<<otg<<endl;
}
int main()
{
    speed();
    read();
	return 0;
}
